#ifndef FM2_FILEMONITOR_H
#define FM2_FILEMONITOR_H

#include "../libfmqtglobals.h"
#include <QObject>
#include "gioptrs.h"
#include "filepath.h"
#include <QFileSystemWatcher>
#include <QFileInfoList>

namespace Fm {

typedef  enum FileChangeType
{
    New,
    Delete,
    Rename,
    Change
}FileChangeType;

class LIBFM_QT_API FileMonitor: public QObject {
    Q_OBJECT
public:

    explicit FileMonitor();
    FileMonitor(const QString& strDirectory, QObject *parent = nullptr);

Q_SIGNALS:
    void sigDirChange(const FileChangeType& type, const QString& strFilePath );

public Q_SLOTS:
    void slotDirectoryChanged(const QString& strDirectory);
    void slotFileChanged(const QString& file);
private:
    QStringList GetFileNames( const QFileInfoList& fileInfoList );

private:
    QString m_strMonitorDirectory;
    QStringList m_strListFileNames;
    QFileSystemWatcher* m_pDirectoryWatcher;

private:
    GFileMonitorPtr monitor_;
};

} // namespace Fm

#endif // FM2_FILEMONITOR_H
